using System;
using EPiServer.Common;

namespace EPiAbstractions.Common
{
    public class LogHandlerFacade : ILogHandlerFacade
    {
        private static LogHandlerFacade _instance;

        public static LogHandlerFacade Instance
        {
            get
            {
                if (_instance == null)
                    _instance = new LogHandlerFacade();

                return _instance;
            }

            set { _instance = value; }
        }

        #region ILogHandlerFacade Members

        public virtual void WriteLogEntry(String message, LogEntryType type)
        {
            LogHandler.WriteLogEntry(message, type);
        }

        public virtual void WriteLogEntry(String source, String message, LogEntryType type)
        {
            LogHandler.WriteLogEntry(source, message, type);
        }

        #endregion
    }
}